diff -Naur usbip-0.1.4/drivers/2.6.19/Makefile trunk/drivers/2.6.19/Makefile
--- usbip-0.1.4/drivers/2.6.19/Makefile	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/Makefile	2007-05-18 11:10:08.000000000 +0200
@@ -1,6 +1,6 @@
 # Makefile for the USB/IP driver
 #
-# $Id: Makefile 97 2006-03-31 16:08:40Z taka-hir $
+# $Id: Makefile 243 2007-02-06 12:50:03Z taka-hir $
 #
 # Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
 #
@@ -51,7 +51,11 @@
 
 
 default:
-	make -C $(KSOURCE) LANG=C KBUILD_VERBOSE=${KBUILD_VERBOSE}  SUBDIRS=`pwd` modules
+	make -C $(KSOURCE) LANG=C KBUILD_VERBOSE=${KBUILD_VERBOSE}  M=`pwd` modules
+
+check:
+	#make -C $(KSOURCE) LANG=C KBUILD_VERBOSE=${KBUILD_VERBOSE} C=1 M=`pwd` modules checkstack namespacecheck headers_check
+	make -C $(KSOURCE) LANG=C KBUILD_VERBOSE=${KBUILD_VERBOSE} C=1 M=`pwd` modules
 
 .PHONY: cscope
 cscope:
@@ -59,5 +63,5 @@
 
 .PHONY: clean
 clean:
-	make -C $(KSOURCE) LANG=C KBUILD_VERBOSE=${KBUILD_VERBOSE}  SUBDIRS=`pwd` clean
+	make -C $(KSOURCE) LANG=C KBUILD_VERBOSE=${KBUILD_VERBOSE}  M=`pwd` clean
 	rm -f *.x *~
diff -Naur usbip-0.1.4/drivers/2.6.19/stub_dev.c trunk/drivers/2.6.19/stub_dev.c
--- usbip-0.1.4/drivers/2.6.19/stub_dev.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/stub_dev.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: stub_dev.c 198 2006-11-12 10:32:49Z taka-hir $
+ * $Id: stub_dev.c 243 2007-02-06 12:50:03Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -62,7 +62,7 @@
 	.name		= "usbip",
 
 	.probe		= stub_probe,
-	.disconnect 	= stub_disconnect,
+	.disconnect	= stub_disconnect,
 
 	.id_table	= stub_table,
 };
@@ -134,9 +134,11 @@
 			return -EINVAL;
 		}
 
+#if 0
 		setnodelay(socket);
 		setkeepalive(socket);
 		setreuse(socket);
+#endif
 
 		sdev->ud.tcp_socket = socket;
 
@@ -330,7 +332,8 @@
 
 	sdev->ud.side = USBIP_STUB;
 	sdev->ud.status = SDEV_ST_AVAILABLE;
-	sdev->ud.lock = SPIN_LOCK_UNLOCKED;
+	// sdev->ud.lock = SPIN_LOCK_UNLOCKED;
+	spin_lock_init(&sdev->ud.lock);
 	sdev->ud.tcp_socket = NULL;
 
 	INIT_LIST_HEAD(&sdev->priv_init);
@@ -338,7 +341,8 @@
 	INIT_LIST_HEAD(&sdev->priv_free);
 	INIT_LIST_HEAD(&sdev->unlink_free);
 	INIT_LIST_HEAD(&sdev->unlink_tx);
-	sdev->priv_lock = SPIN_LOCK_UNLOCKED;
+	// sdev->priv_lock = SPIN_LOCK_UNLOCKED;
+	spin_lock_init(&sdev->priv_lock);
 
 	init_waitqueue_head(&sdev->tx_waitq);
 
@@ -368,9 +372,12 @@
 
 /*
  * If a usb device has multiple active interfaces, this driver is bound to all
- * the active interfaces. However, usbip exports *a* usb device (i.e. not *an*
+ * the active interfaces. However, usbip exports *a* usb device (i.e., not *an*
  * active interface). Currently, a userland program must ensure that it
  * looks at the usbip's sysfs entries of only the first active interface.
+ *
+ * TODO: use "struct usb_device_driver" to bind a usb device.
+ * However, it seems it is not fully supported in mainline kerenel yet (2.6.19.2).
  */
 static int stub_probe(struct usb_interface *interface, const struct usb_device_id *id)
 {
diff -Naur usbip-0.1.4/drivers/2.6.19/stub.h trunk/drivers/2.6.19/stub.h
--- usbip-0.1.4/drivers/2.6.19/stub.h	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/stub.h	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: stub.h 198 2006-11-12 10:32:49Z taka-hir $
+ * $Id: stub.h 242 2007-02-06 12:00:19Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -38,9 +38,9 @@
 	 * It is allocated as stub_priv_cache and assigned to urb->context.
 	 *
 	 * stub_priv is always linked to any one of 3 lists;
-	 * 	priv_init: linked to this until the comletion of a urb.
-	 * 	priv_tx  : linked to this after the completion of a urb.
-	 * 	priv_free: linked to this after the sending of the result.
+	 *	priv_init: linked to this until the comletion of a urb.
+	 *	priv_tx  : linked to this after the completion of a urb.
+	 *	priv_free: linked to this after the sending of the result.
 	 *
 	 * Any of these list operations should be locked by priv_lock.
 	 */
@@ -74,7 +74,7 @@
 };
 
 
-extern kmem_cache_t *stub_priv_cache;
+extern struct kmem_cache *stub_priv_cache;
 
 
 /*-------------------------------------------------------------------------*/
diff -Naur usbip-0.1.4/drivers/2.6.19/stub_main.c trunk/drivers/2.6.19/stub_main.c
--- usbip-0.1.4/drivers/2.6.19/stub_main.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/stub_main.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: stub_main.c 198 2006-11-12 10:32:49Z taka-hir $
+ * $Id: stub_main.c 243 2007-02-06 12:50:03Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -25,14 +25,14 @@
 #include "stub.h"
 
 /* Version Information */
-#define DRIVER_VERSION "$Id: stub_main.c 198 2006-11-12 10:32:49Z taka-hir $"
+#define DRIVER_VERSION "$Id: stub_main.c 243 2007-02-06 12:50:03Z taka-hir $"
 #define DRIVER_AUTHOR "Takahiro Hirofuchi <taka-hir@is.naist.jp>"
 #define DRIVER_DESC "Stub Driver for USB/IP"
 
 
 
 /* stub_priv is allocated from stub_priv_cache */
-kmem_cache_t *stub_priv_cache = NULL;
+struct kmem_cache *stub_priv_cache = NULL;
 
 
 /*-------------------------------------------------------------------------*/
@@ -47,7 +47,7 @@
  */
 #define MAX_BUSID 16
 static char busid_table[MAX_BUSID][BUS_ID_SIZE];
-spinlock_t busid_table_lock = SPIN_LOCK_UNLOCKED;
+static spinlock_t busid_table_lock;
 
 
 int match_busid(char *busid)
@@ -261,6 +261,7 @@
 	info(DRIVER_DESC "" DRIVER_VERSION);
 
 	memset(busid_table, 0, sizeof(busid_table));
+	spin_lock_init(&busid_table_lock);
 
 	ret = driver_create_file(&stub_driver.drvwrap.driver, &driver_attr_match_busid);
 	if (ret) {
diff -Naur usbip-0.1.4/drivers/2.6.19/stub_rx.c trunk/drivers/2.6.19/stub_rx.c
--- usbip-0.1.4/drivers/2.6.19/stub_rx.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/stub_rx.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: stub_rx.c 197 2006-10-24 10:20:25Z taka-hir $
+ * $Id: stub_rx.c 241 2007-02-06 10:21:58Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -67,7 +67,7 @@
 
 	/*
 	 * The stalled endpoint is specified in the wIndex value. The endpoint
-	 * of the urb is the target of this clear_halt request (i.e. control
+	 * of the urb is the target of this clear_halt request (i.e., control
 	 * endpoint).
 	 */
 	target_endp = le16_to_cpu(req->wIndex) & 0x000f;
@@ -145,7 +145,7 @@
 		return;
 
 	if (is_clear_halt_cmd(urb))
-		/* treak clear_halt */
+		/* tweak clear_halt */
 		 tweak_clear_halt_cmd(urb);
 
 	else if (is_set_interface_cmd(urb))
@@ -187,11 +187,11 @@
 			uinfo("unlink urb %p\n", priv->urb);
 
 			/*
-			 * This matched urb is not completed yet (i.e. be in
+			 * This matched urb is not completed yet (i.e., be in
 			 * flight in usb hcd hardware/driver). Now we are
 			 * cancelling it. The unlinking flag means that we are
 			 * now not going to return the normal result pdu of a
-			 * submittion request, but going to return a result pdu
+			 * submission request, but going to return a result pdu
 			 * of the unlink request.
 			 */
 			priv->unlinking = 1;
@@ -217,6 +217,10 @@
 			 * though submission is completed and actual unlinking
 			 * is not executed. OK?
 			 */
+			/* In the above case, urb->status is not -ECONNRESET,
+			 * so a driver in a client host will know the failure
+			 * of the unlink request ?
+			 */
 			ret = usb_unlink_urb(priv->urb);
 			if (ret != -EINPROGRESS)
 				uerr("faild to unlink a urb %p, ret %d\n", priv->urb, ret);
@@ -352,6 +356,7 @@
 	if (usbip_recv_iso(ud, priv->urb) < 0)
 		return;
 
+	/* no need to submit an intercepted request, but harmless? */
 	tweak_special_requests(priv->urb);
 
 	/* urb is now ready to submit */
@@ -364,7 +369,7 @@
 
 		/*
 		 * Pessimistic.
-		 * This connection will be discared.
+		 * This connection will be discarded.
 		 */
 		usbip_event_add(ud, SDEV_EVENT_ERROR_SUBMIT);
 	}
@@ -386,7 +391,7 @@
 	memset(&pdu, 0, sizeof(pdu));
 
 
-	/* 1. recieve a pdu header */
+	/* 1. receive a pdu header */
 	ret = usbip_xmit(0, ud->tcp_socket, (char *) &pdu, sizeof(pdu),0);
 	if (ret != sizeof(pdu)) {
 		uerr("recv a header, %d\n", ret);
@@ -429,7 +434,7 @@
 
 	while (1) {
 		if (signal_pending(current)) {
-			dbg_stub_rx("signal catched!\n");
+			dbg_stub_rx("signal caught!\n");
 			break;
 		}
 
diff -Naur usbip-0.1.4/drivers/2.6.19/stub_tx.c trunk/drivers/2.6.19/stub_tx.c
--- usbip-0.1.4/drivers/2.6.19/stub_tx.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/stub_tx.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: stub_tx.c 198 2006-11-12 10:32:49Z taka-hir $
+ * $Id: stub_tx.c 209 2006-11-15 09:39:53Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -350,10 +350,10 @@
 		/*
 		 * send_ret_submit comes earlier than send_ret_unlink.  stub_rx
 		 * looks at only priv_init queue. If the completion of a URB is
-		 * earlier than the recieve of CMD_UNLINK, priv is moved to
+		 * earlier than the receive of CMD_UNLINK, priv is moved to
 		 * priv_tx queue and stub_rx does not find the target priv. In
-		 * this case, vhci_rx recieves the result of the submit request
-		 * and then recieves the result of the unlink request. The
+		 * this case, vhci_rx receives the result of the submit request
+		 * and then receives the result of the unlink request. The
 		 * result of the submit is given back to the usbcore as the
 		 * completion of the unlink request. The request of the
 		 * unlink is ignored. This is ok because a driver who calls
diff -Naur usbip-0.1.4/drivers/2.6.19/usbip_common.c trunk/drivers/2.6.19/usbip_common.c
--- usbip-0.1.4/drivers/2.6.19/usbip_common.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/usbip_common.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: usbip_common.c 197 2006-10-24 10:20:25Z taka-hir $
+ * $Id: usbip_common.c 242 2007-02-06 12:00:19Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -523,6 +523,9 @@
 	return result;
 }
 
+
+/* now a usrland utility should set options. */
+#if 0
 int setquickack(struct socket *socket)
 {
 	mm_segment_t oldfs;
@@ -572,6 +575,7 @@
 {
 	socket->sk->sk_reuse = 1;
 }
+#endif
 
 struct socket *sockfd_to_socket(unsigned int sockfd)
 {
@@ -791,7 +795,7 @@
 			BUG();
 	}
 }
-	
+
 static void usbip_iso_pakcet_correct_endian(struct usbip_iso_packet_descriptor *iso, int send)
 {
 	/* does not need all members. but copy all simply. */
diff -Naur usbip-0.1.4/drivers/2.6.19/usbip_common.h trunk/drivers/2.6.19/usbip_common.h
--- usbip-0.1.4/drivers/2.6.19/usbip_common.h	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/usbip_common.h	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: usbip_common.h 197 2006-10-24 10:20:25Z taka-hir $
+ * $Id: usbip_common.h 242 2007-02-06 12:00:19Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -43,11 +43,11 @@
 #ifdef CONFIG_USB_DEBUG
 
 #define udbg(fmt, args...)						\
-	do{								\
+	do {								\
 		printk(KERN_DEBUG "%-10s:(%s,%d) %s: " fmt,		\
 			(in_interrupt() ? "interrupt" : (current)->comm),\
 			__FILE__, __LINE__, __FUNCTION__ , ##args);	\
-	}while(0)
+	} while(0)
 
 #else  /* CONFIG_USB_DEBUG */
 
@@ -88,7 +88,7 @@
 
 #define dbg_with_flag(flag, fmt, args...)		\
 	do {						\
-		if(flag & usbip_debug_flag) 		\
+		if(flag & usbip_debug_flag)		\
 			udbg(fmt , ##args);		\
 	} while(0)
 
@@ -254,14 +254,16 @@
 	return interface->cur_altsetting->desc.bInterfaceNumber;
 }
 
+#if 0
 int setnodelay(struct socket *);
 int setquickack(struct socket *);
 int setkeepalive(struct socket *socket);
 void setreuse(struct socket *);
+#endif
+
 struct socket *sockfd_to_socket(unsigned int);
 int set_sockaddr(struct socket *socket, struct sockaddr_storage *ss);
 
-
 void usbip_dump_urb (struct urb *purb);
 void usbip_dump_header(struct usbip_header *pdu);
 
@@ -316,15 +318,15 @@
 #define USBIP_EH_RESET		(1 << 2)
 #define USBIP_EH_UNUSABLE	(1 << 3)
 
-#define SDEV_EVENT_REMOVED     		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET | USBIP_EH_BYE )
-#define	SDEV_EVENT_DOWN	       		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
-#define	SDEV_EVENT_ERROR_TCP   		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
+#define SDEV_EVENT_REMOVED		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET | USBIP_EH_BYE )
+#define	SDEV_EVENT_DOWN			( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
+#define	SDEV_EVENT_ERROR_TCP		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
 #define	SDEV_EVENT_ERROR_SUBMIT		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
 #define	SDEV_EVENT_ERROR_MALLOC		( USBIP_EH_SHUTDOWN | USBIP_EH_UNUSABLE )
 
-#define	VDEV_EVENT_REMOVED     		( USBIP_EH_SHUTDOWN | USBIP_EH_BYE )
-#define	VDEV_EVENT_DOWN	       		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
-#define	VDEV_EVENT_ERROR_TCP   		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
+#define	VDEV_EVENT_REMOVED		( USBIP_EH_SHUTDOWN | USBIP_EH_BYE )
+#define	VDEV_EVENT_DOWN			( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
+#define	VDEV_EVENT_ERROR_TCP		( USBIP_EH_SHUTDOWN | USBIP_EH_RESET )
 #define	VDEV_EVENT_ERROR_MALLOC		( USBIP_EH_SHUTDOWN | USBIP_EH_UNUSABLE)
 
 	unsigned long event;
diff -Naur usbip-0.1.4/drivers/2.6.19/usbip_event.c trunk/drivers/2.6.19/usbip_event.c
--- usbip-0.1.4/drivers/2.6.19/usbip_event.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/usbip_event.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: usbip_event.c 208 2006-11-12 15:22:24Z taka-hir $
+ * $Id: usbip_event.c 205 2006-11-12 15:00:07Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
diff -Naur usbip-0.1.4/drivers/2.6.19/vhci_hcd.c trunk/drivers/2.6.19/vhci_hcd.c
--- usbip-0.1.4/drivers/2.6.19/vhci_hcd.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/vhci_hcd.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: vhci_hcd.c 198 2006-11-12 10:32:49Z taka-hir $
+ * $Id: vhci_hcd.c 243 2007-02-06 12:50:03Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -24,7 +24,7 @@
 #include "usbip_common.h"
 #include "vhci.h"
 
-#define DRIVER_VERSION " $Id: vhci_hcd.c 198 2006-11-12 10:32:49Z taka-hir $ "
+#define DRIVER_VERSION " $Id: vhci_hcd.c 243 2007-02-06 12:50:03Z taka-hir $ "
 #define DRIVER_AUTHOR "HIROFUCHI Takahiro <taka-hir@is.naist.jp>"
 #define DRIVER_DESC "Virtual Host Controller Interface Driver for USB/IP"
 #define DRIVER_LICENCE "GPL"
@@ -36,12 +36,12 @@
 
 /*
  * TODO
- * 	- update root hub emulation
- * 	- move the emulation code to userland ?
- * 		poring to other operating systems
- * 		minimize kernel code
- * 	- add suspend/resume code
- * 	- clean up everything
+ *	- update root hub emulation
+ *	- move the emulation code to userland ?
+ *		poring to other operating systems
+ *		minimize kernel code
+ *	- add suspend/resume code
+ *	- clean up everything
  */
 
 
@@ -611,7 +611,7 @@
 	vhci_tx_urb(urb);
 
 
-	spin_unlock_irqrestore (&the_controller->lock, flags);
+	spin_unlock_irqrestore(&the_controller->lock, flags);
 
 	return 0;
 
@@ -626,8 +626,8 @@
 
 
 /*
- * vhci_rx gives back the urb after recieving the reply of the urb.  If an
- * unlink pdu is sent or not, vhci_rx recieves a normal return pdu and gives
+ * vhci_rx gives back the urb after receiving the reply of the urb.  If an
+ * unlink pdu is sent or not, vhci_rx receives a normal return pdu and gives
  * back its urb. For the driver unlinking the urb, the content of the urb is
  * not important, but the calling to its completion handler is important; the
  * completion of unlinking is notified by the completion handler.
@@ -635,7 +635,7 @@
  *
  * CLIENT SIDE
  *
- * - When vhci_hcd recieves RET_SUBMIT,
+ * - When vhci_hcd receives RET_SUBMIT,
  *
  *	- case 1a). the urb of the pdu is not unlinking.
  *		- normal case
@@ -645,29 +645,29 @@
  *		- usbip.ko will return a reply of the unlinking request.
  *		=> give back the urb now and go to case 2b).
  *
- * - When vhci_hcd recieves RET_UNLINK,
+ * - When vhci_hcd receives RET_UNLINK,
  *
- *   	- case 2a). a submit request is still pending in vhci_hcd.
- *   		- urb was really pending in usbip.ko and urb_unlink_urb() was
- *   		  completed there.
- *   		=> free a pending submit request
- *   		=> notify unlink completeness by giving back the urb
- *
- *   	- case 2b). a submit request is *not* pending in vhci_hcd.
- *   		- urb was already given back to the core driver.
- *   		=> do not give back the urb
+ *	- case 2a). a submit request is still pending in vhci_hcd.
+ *		- urb was really pending in usbip.ko and urb_unlink_urb() was
+ *		  completed there.
+ *		=> free a pending submit request
+ *		=> notify unlink completeness by giving back the urb
+ *
+ *	- case 2b). a submit request is *not* pending in vhci_hcd.
+ *		- urb was already given back to the core driver.
+ *		=> do not give back the urb
  *
  *
  * SERVER SIDE
  *
- * - When usbip recieves CMD_UNLINK,
+ * - When usbip receives CMD_UNLINK,
  *
  *	- case 3a). the urb of the unlink request is now in submission.
  *		=> do usb_unlink_urb().
  *		=> after the unlink is completed, send RET_UNLINK.
  *
  *	- case 3b). the urb of the unlink request is not in submission.
- *		- may be already completed or never be recieved
+ *		- may be already completed or never be received
  *		=> send RET_UNLINK
  *
  */
@@ -736,12 +736,12 @@
 
 		spin_unlock_irqrestore(&vdev->priv_lock, flags2);
 	}
-	
+
 	spin_unlock_irqrestore(&the_controller->lock, flags);
 
 	/*
 	 * If tcp connection is alive, we have sent CMD_UNLINK.
-	 * vhci_rx will recieve RET_UNLINK and giveb back the URB.
+	 * vhci_rx will receive RET_UNLINK and giveb back the URB.
 	 * Otherwise, we give back it here.
 	 */
 	if (!vdev->ud.tcp_socket) {
@@ -805,11 +805,11 @@
 	/*
 	 * rh_port_disconnect() is a trigger of ...
 	 *   usb_disable_device():
-	 * 	disable all the endpoints for a USB device.
+	 *	disable all the endpoints for a USB device.
 	 *   usb_disable_endpoint():
-	 * 	disable endpoints. pending urbs are unlinked(dequeued).
+	 *	disable endpoints. pending urbs are unlinked(dequeued).
 	 *
-	 * NOTE: After calling rh_port_disconnect(), the USB device driver of a
+	 * NOTE: After calling rh_port_disconnect(), the USB device drivers of a
 	 * deteched device should release used urbs in a cleanup function(i.e.
 	 * xxx_disconnect()). Therefore, vhci_hcd does not need to release
 	 * pushed urbs and their private data in this function.
@@ -819,7 +819,7 @@
 	 * gives back pushed urbs and frees their private data by request of
 	 * the cleanup function of a USB driver. When unlinking a urb with an
 	 * active connection, vhci_dequeue() does not give back the urb which
-	 * is actually given back by vhci_rx after recieving its return pdu.
+	 * is actually given back by vhci_rx after receiving its return pdu.
 	 *
 	 */
 	rh_port_disconnect(vdev->rhport);
@@ -863,13 +863,15 @@
 
 	vdev->ud.side   = USBIP_VHCI;
 	vdev->ud.status = VDEV_ST_NULL;
-	vdev->ud.lock   = SPIN_LOCK_UNLOCKED;
+	// vdev->ud.lock   = SPIN_LOCK_UNLOCKED;
+	spin_lock_init(&vdev->ud.lock);
 
 	INIT_LIST_HEAD(&vdev->priv_rx);
 	INIT_LIST_HEAD(&vdev->priv_tx);
 	INIT_LIST_HEAD(&vdev->unlink_tx);
 	INIT_LIST_HEAD(&vdev->unlink_rx);
-	vdev->priv_lock = SPIN_LOCK_UNLOCKED;
+	// vdev->priv_lock = SPIN_LOCK_UNLOCKED;
+	spin_lock_init(&vdev->priv_lock);
 
 	init_waitqueue_head(&vdev->waitq_tx);
 
@@ -1037,7 +1039,7 @@
 		the_controller = NULL;
 		return ret;
 	}
-	
+
 
 	dbg_vhci_hc("bye\n");
 	return 0;
@@ -1113,7 +1115,7 @@
 /*
  * The VHCI 'device' is 'virtual'; not a real plug&play hardware.
  * We need to add this virtual device as a platform device arbitrarily:
- * 	1. platform_device_register()
+ *	1. platform_device_register()
  */
 static void the_pdev_release(struct device *dev)
 {
diff -Naur usbip-0.1.4/drivers/2.6.19/vhci_rx.c trunk/drivers/2.6.19/vhci_rx.c
--- usbip-0.1.4/drivers/2.6.19/vhci_rx.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/vhci_rx.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: vhci_rx.c 198 2006-11-12 10:32:49Z taka-hir $
+ * $Id: vhci_rx.c 234 2006-12-15 04:34:04Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -143,7 +143,7 @@
 {
 	struct vhci_unlink *unlink;
 	struct urb *urb;
-	
+
 	usbip_dump_header(pdu);
 
 	unlink = dequeue_pending_unlink(vdev, pdu);
@@ -156,7 +156,7 @@
 	if (!urb) {
 		/*
 		 * I get the result of a unlink request. But, it seems that I
-		 * already recieved the result of its submit result and gave
+		 * already received the result of its submit result and gave
 		 * back the URB.
 		 */
 		uinfo("the urb (seqnum %d) was already given backed\n", pdu->base.seqnum);
@@ -187,7 +187,7 @@
 	memset(&pdu, 0, sizeof(pdu));
 
 
-	/* 1. recieve a pdu header */
+	/* 1. receive a pdu header */
 	ret = usbip_xmit(0, ud->tcp_socket, (char *) &pdu, sizeof(pdu),0);
 	if (ret != sizeof(pdu)) {
 		uerr("recv a header, %d\n", ret);
diff -Naur usbip-0.1.4/drivers/2.6.19/vhci_sysfs.c trunk/drivers/2.6.19/vhci_sysfs.c
--- usbip-0.1.4/drivers/2.6.19/vhci_sysfs.c	2007-05-18 11:10:10.000000000 +0200
+++ trunk/drivers/2.6.19/vhci_sysfs.c	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: vhci_sysfs.c 195 2006-10-24 10:11:08Z taka-hir $
+ * $Id: vhci_sysfs.c 242 2007-02-06 12:00:19Z taka-hir $
  *
  * Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
  *
@@ -213,7 +213,7 @@
 			rhport, sockfd, busnum, devnum, speed);
 
 
-	/* check recieved parameters */
+	/* check received parameters */
 	if (valid_args(rhport, busnum, devnum, speed) < 0)
 		return -EINVAL;
 
@@ -222,8 +222,9 @@
 	if (!socket)
 		return  -EINVAL;
 
+#if 0
 	setnodelay(socket);
-
+#endif
 
 	/* now need lock until setting vdev status as used */
 
diff -Naur usbip-0.1.4/NEWS trunk/NEWS
--- usbip-0.1.4/NEWS	2007-05-18 11:10:10.000000000 +0200
+++ trunk/NEWS	2007-05-18 11:10:08.000000000 +0200
@@ -1,5 +1,20 @@
 # vim:tw=78:ts=4:expandtab:ai:sw=4
-# $Id: NEWS 208 2006-11-12 15:22:24Z taka-hir $
+# $Id: NEWS 243 2007-02-06 12:50:03Z taka-hir $
+
+usbip-0.1.5
+    - Fix: "make dist" works.
+    - Cleanup: use autoreconf instead.
+    - Cleanup: change vhci_driver as a global value in libusbip.
+    - Cleanup: change stub_driver as a global value in libusbip.
+    - Cleanup: trim unused spaces.
+    - Add: version info in configure.ac
+    - Fix: auto detection of "glib-2.0 >= 2.6.0"
+    - Add: mailing list information in README
+    - Cleanup: use daemon(3), instead.
+    - Add: usb.ids 
+    - setsockopt in userland
+    - Add: 2.6.20 support?
+    - Fix: use spin_lock_init() instead of SPIN_...
 
 usbip-0.1.4
     - Fix: compile error & warning fix for 2.6.19
diff -Naur usbip-0.1.4/README trunk/README
--- usbip-0.1.4/README	2007-05-18 11:10:10.000000000 +0200
+++ trunk/README	2007-05-18 11:10:08.000000000 +0200
@@ -1,6 +1,6 @@
 # vim:tw=78:ts=4:expandtab:ai:sw=4
 #
-# $Id: README 124 2006-06-02 13:45:36Z taka-hir $
+# $Id: README 242 2007-02-06 12:00:19Z taka-hir $
 #
 # Copyright (C) 2003-2006 Takahiro Hirofuchi <taka-hir@is.naist.jp>
 
@@ -84,8 +84,21 @@
     A.  No.
 
 
+Public Forum and Mailing List
+    They are available in the project page on sourceforge.net.
+        Forums
+            http://sourceforge.net/forum/forum.php?forum_id=418509
+        Mailing List
+            http://sourceforge.net/mail/?group_id=122798
+
+
+RSS feeds (e.g., the latest file releases)
+    http://sourceforge.net/export/rss2_project.php?group_id=122798
+
+
 Contact
     Bug reports, feature requests, and your comments are welcome.
+    Please use the above forums and the mailing list, or contact me.
 
     Nara Institute of Science and Technology
     Takahiro Hirofuchi <taka-hir@is.naist.jp>
diff -Naur usbip-0.1.4/src/autogen.sh trunk/src/autogen.sh
--- usbip-0.1.4/src/autogen.sh	1970-01-01 01:00:00.000000000 +0100
+++ trunk/src/autogen.sh	2007-05-18 11:10:08.000000000 +0200
@@ -0,0 +1,9 @@
+#!/bin/sh -x
+
+#aclocal
+#autoheader
+#libtoolize --copy --force
+#automake-1.9 -acf
+#autoconf
+
+autoreconf -i -f -v
diff -Naur usbip-0.1.4/src/cleanup trunk/src/cleanup
--- usbip-0.1.4/src/cleanup	2007-05-18 11:10:10.000000000 +0200
+++ trunk/src/cleanup	2007-05-18 11:10:08.000000000 +0200
@@ -5,6 +5,6 @@
 	make distclean
 fi
 
-FILES="configure cscope.out Makefile.in depcomp compile config.guess config.sub config.h.in~ config.log config.status libtool config.h.in autom4te.cache missing aclocal.m4 install-sh cmd/Makefile.in lib/Makefile.in"
+FILES="configure cscope.out Makefile.in depcomp compile config.guess config.sub config.h.in~ config.log config.status ltmain.sh libtool config.h.in autom4te.cache missing aclocal.m4 install-sh cmd/Makefile.in lib/Makefile.in Makefile lib/Makefile cmd/Makefile"
 
 rm -Rf $FILES
diff -Naur usbip-0.1.4/src/cmd/bind-driver.c trunk/src/cmd/bind-driver.c
--- usbip-0.1.4/src/cmd/bind-driver.c	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/cmd/bind-driver.c	2007-05-18 11:10:07.000000000 +0200
@@ -8,6 +8,8 @@
 	{"usbip",	required_argument,	NULL, 'u'},
 	{"other",	required_argument,	NULL, 'o'},
 	{"list",	no_argument,		NULL, 'l'},
+	{"scriptlist",	no_argument,	NULL, 's'},
+	{"autobind",	no_argument,	NULL, 'a'},
 	{"help",	no_argument,		NULL, 'h'},
 	{NULL,		0,			NULL,  0}
 };
@@ -60,7 +62,7 @@
 	snprintf(unbind_path, sizeof(unbind_path), unbind_path_format, busid);
 
 	fd = open(unbind_path, O_WRONLY);
-	if (fd < 0) 
+	if (fd < 0)
 		return -1;
 
 	ret = write(fd, busid, strnlen(busid, BUS_ID_SIZE));
@@ -95,7 +97,7 @@
 	snprintf(bind_path, sizeof(bind_path), bind_path_format, driver);
 
 	fd = open(bind_path, O_WRONLY);
-	if (fd < 0) 
+	if (fd < 0)
 		return -1;
 
 	ret = write(fd, busid, strnlen(busid, BUS_ID_SIZE));
@@ -139,11 +141,11 @@
 		g_message("skip unbinding of hub");
 		return -1;
 	}
- 
+
  	for (i = 0; i < ninterface; i++) {
  		char driver[PATH_MAX];
 		int ret;
- 
+
 		bzero(&driver, sizeof(driver));
 
  		getdriver(busid, configvalue, i, driver, PATH_MAX-1);
@@ -188,7 +190,7 @@
 		g_debug("read config and ninf value, removed?");
 		return -1;
 	}
- 
+
  	for (i = 0; i < ninterface; i++) {
 		int ret;
 
@@ -207,7 +209,7 @@
 		return 0;
 }
 
- 
+
 static int use_device_by_usbip(char *busid)
 {
 	int ret;
@@ -289,7 +291,7 @@
 		g_error("regcomp: %s\n", strerror(errno));
 
 	ret = regexec(&regex, busid, 0, pmatch, 0);
-	if (ret) 
+	if (ret)
 		return 0;	/* not matched */
 
 	return 1;
@@ -342,6 +344,104 @@
 	return 0;
 }
 
+static int show_devices_script(void)
+{
+	DIR *dir;
+
+	dir = opendir("/sys/bus/usb/devices/");
+	if (!dir)
+		g_error("opendir: %s", strerror(errno));
+
+	for (;;) {
+		struct dirent *dirent;
+		char *busid;
+
+		dirent = readdir(dir);
+		if (!dirent)
+			break;
+
+		busid = dirent->d_name;
+
+		if (is_usb_device(busid)) {
+			char name[100] = {'\0'};
+			char driver[100] =  {'\0'};
+			int conf, ninf = 0;
+			int i;
+			int islocal = 0;
+
+			conf = read_bConfigurationValue(busid);
+			ninf = read_bNumInterfaces(busid);
+
+			getdevicename(busid, name, sizeof(name));
+
+			for (i = 0; i < ninf; i++) {
+				getdriver(busid, conf, i, driver, sizeof(driver));
+				
+				if (strncmp(driver, "usbhid", 6) == 0 || strncmp(driver, "usb-storage", 11) == 0) {
+					islocal = 1;
+					break;
+				}
+			}
+			
+			if (islocal == 0)
+				printf("%s|%s|%s\n", busid, driver, name);
+		}
+	}
+
+	closedir(dir);
+
+	return 0;
+}
+
+static int auto_bind(void)
+{
+	DIR *dir;
+
+	dir = opendir("/sys/bus/usb/devices/");
+	if (!dir)
+		g_error("opendir: %s", strerror(errno));
+
+	for (;;) {
+		struct dirent *dirent;
+		char *busid;
+
+		dirent = readdir(dir);
+		if (!dirent)
+			break;
+
+		busid = dirent->d_name;
+
+		if (is_usb_device(busid)) {
+			char name[100] = {'\0'};
+			char driver[100] =  {'\0'};
+			int conf, ninf = 0;
+			int i;
+			int islocal = 0;
+
+			conf = read_bConfigurationValue(busid);
+			ninf = read_bNumInterfaces(busid);
+
+			getdevicename(busid, name, sizeof(name));
+
+			for (i = 0; i < ninf; i++) {
+				getdriver(busid, conf, i, driver, sizeof(driver));
+				
+				if (strncmp(driver, "usbhid", 6) == 0 || strncmp(driver, "usb-storage", 11) == 0) {
+					islocal = 1;
+					break;
+				}
+			}
+			
+			if (islocal == 0)
+				use_device_by_usbip(busid);
+		}
+	}
+
+	closedir(dir);
+
+	return 0;
+}
+
 static void show_help(void)
 {
 	printf("Usage: bind-driver [OPTION]\n");
@@ -349,25 +449,29 @@
 	printf("  --usbip busid        make a device exportable by USB/IP\n");
 	printf("  --other busid        use a device by a local driver\n");
 	printf("  --list               print usb devices and their drivers\n");
+	printf("  --scriptlist      print usb devices and their drivers. handy for scripts\n");
+	printf("  --autobind     make all devices exportable by USB/IP\n");
 }
 
 int main(int argc, char **argv)
 {
-	char *busid = NULL; 
+	char *busid = NULL;
 
 	enum {
 		cmd_unknown = 0,
 		cmd_use_by_usbip,
 		cmd_use_by_other,
 		cmd_list,
+		cmd_scriptlist,
+		cmd_autobind,
 		cmd_help
 	} cmd = cmd_unknown;
 
-	for(;;) {
+	for (;;) {
 		int c;
 		int index = 0;
 
-		c = getopt_long(argc, argv, "u:o:hl", longopts, &index);
+		c = getopt_long(argc, argv, "u:o:hlsa", longopts, &index);
 		if (c == -1)
 			break;
 
@@ -383,6 +487,12 @@
 			case 'l' :
 				cmd = cmd_list;
 				break;
+			case 's' :
+				cmd = cmd_scriptlist;
+				break;
+			case 'a' :
+				cmd = cmd_autobind;
+				break;
 			case 'h':
 			case '?':
 				cmd = cmd_help;
@@ -405,6 +515,12 @@
 		case cmd_list:
 			show_devices();
 			break;
+		case cmd_scriptlist:
+			show_devices_script();
+			break;
+		case cmd_autobind:
+			auto_bind();
+			break;
 		case cmd_help:
 		case cmd_unknown:
 			show_help();
diff -Naur usbip-0.1.4/src/cmd/Makefile.am trunk/src/cmd/Makefile.am
--- usbip-0.1.4/src/cmd/Makefile.am	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/cmd/Makefile.am	2007-05-18 11:10:07.000000000 +0200
@@ -1,12 +1,15 @@
 bin_PROGRAMS = usbip usbipd bind_driver
+
 usbip_SOURCES = vhci_attach.c usbip_network.c usbip_network.h
 usbipd_SOURCES = stub_server.c usbip_network.c usbip_network.h
 bind_driver_SOURCES = bind-driver.c utils.c utils.h
-bind_driver_CFLAGS = -Wall -g @PACKAGE_CFLAGS@
-bind_driver_LDADD = @PACKAGE_LIBS@
-AM_CPPFLAGS = -I../include -Wall -std=gnu99
-#INCLUDES = -I../include
-LDADD = ../lib/libusbip.la
+
+#bind_driver_CFLAGS = -Wall -W -Wstrict-prototypes @PACKAGE_CFLAGS@
+#bind_driver_LDADD = @PACKAGE_LIBS@
+
+#AM_CPPFLAGS = -I../include -Wall -std=gnu99
+INCLUDES = -I$(top_srcdir)/lib
+LDADD = ../lib/libusbip.la @PACKAGE_LIBS@
 EXTRA_CFLAGS = @EXTRA_CFLAGS@
-AM_CFLAGS = -Wall -W -Wstrict-prototypes $(EXTRA_CFLAGS)
+AM_CFLAGS = -Wall -W -Wstrict-prototypes -std=gnu99 $(EXTRA_CFLAGS) @PACKAGE_CFLAGS@
 
